import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import java.util.StringTokenizer;

 public class ExoReconnaissance1 extends ExerciceReconnaissance{
     int cpt=0;
     int nbClick=0;
     int nbClickAvant=0;
     int nbClickTotal=0;
     ImageIcon iconSmile = new ImageIcon("smiley.jpg");
     ImageIcon iconNotSmile = new ImageIcon("smileynot.jpg");
     JLabel labelSmile;

     StructExoReconnaissance1 exo1;
     ActionListener e;
     Frame fenetre;
     String nomUtilisateur;
   
     int numero;
     
     JLabel enonce = new JLabel ();
     ImageIcon icon;
     JLabel image;
     JPanel pane;
     JButton bouton = new JButton ("OK");
     DNDList targetList = new DNDList();
     DNDList sourceList = new DNDList();
     DefaultListModel targetModel = new DefaultListModel();
     DefaultListModel sourceModel = new DefaultListModel();
     JPanel panelPropositions;
     JPanel panelReponse;
     ImageIcon iconSortie = new ImageIcon("sortie.gif");
     JButton sortie = new JButton("",iconSortie);
   
     int cptClick=0;
     int reussite=0;
     int nbQuestionRep=0;
    

     public ExoReconnaissance1(String nomUrl, Espion e, Eleve etu) {
	 super(nomUrl,e,etu);
	 nomUtilisateur = getEleve().getNom();

	 fenetre = new Frame("Images : niveau facile");
	 fenetre.setSize(1024, 768);
	 fenetre.addWindowListener(new WindowAdapter(){
		 public void windowClosing(WindowEvent e){
		     Object[] options = { "Quitter", "Annuler" };
		     int i= JOptionPane.showOptionDialog(fenetre, "Tu es sr de quitter, dans ce cas on enregistre ton travail", "Quitter?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);
		     if (i == JOptionPane.YES_OPTION){ 
			 String numquestfin = ""+numero;
			 etudiant.modifieHistorique("|reconnaissance|"+nomExercice+"_"+niveau,numquestfin);
						 
			 if(nbQuestionRep>0){
			     double a = ((double)nbQuestionRep/(double)cptClick)*100;
			     reussite = (int)a;
			     mouchard.insertData("|reconnaissance|"+nomExercice+"_"+niveau,nomExercice,1,reussite,0);
			 }
			 fenetre.dispose();
		     }
		 }
	     }
				   );
	 
	 pane = new JPanel();
	 pane.setLayout(null);
	 fenetre.add(pane);
	
    }

	

       public void reprise(){
	   sortie.setBounds(new Rectangle(0,0,50, 20));
	   sortie.addActionListener(new ActionListener(){
		   public void actionPerformed(ActionEvent e){   
		       Object[] options = { "Quitter", "Annuler" };
		     int i= JOptionPane.showOptionDialog(fenetre, "Tu es sr de quitter, dans ce cas on enregistre ton travail", "Quitter?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);

		       if (i == JOptionPane.YES_OPTION){ 
			   String numquestfin = ""+numero;
			   etudiant.modifieHistorique("|reconnaissance|"+nomExercice+"_"+niveau,numquestfin);
			
			   if(nbQuestionRep>0){
			       double a = ((double)nbQuestionRep/(double)cptClick)*100;
			       reussite = (int)a;
			       mouchard.insertData("|reconnaissance|"+nomExercice+"_"+niveau,nomExercice,1,reussite,0);
			   }
			   fenetre.dispose();
		       }
		    		      
		   }
	       }
				    );


	   String rep = etudiant.litHistorique("|reconnaissance|"+nomExercice+"_"+niveau,"");
	  	   
	   if((rep.equals(""))||(rep.equals("0"))){
	       inter(0);
	   }
	   else{
	       int numquestion = (new Integer(rep)).intValue();
	       if(numquestion==nbQuestion){
		   Object[] options = { "Oui", "Non" };
		int n= JOptionPane.showOptionDialog(fenetre, "Tu as dj fait cet exercice et tu l'as fini, veux tu le refaire?", "Reprise?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);

		   if (n == JOptionPane.YES_OPTION){ 
		       inter(0);
		   }
		   else{
		       fenetre.dispose();	   
		   }
	       }
	       else{
		   Object[] options = { "Reprendre", "Recommencer au dbut" };
		   int n1 = JOptionPane.showOptionDialog(fenetre, "Tu as dj commenc cet exercice, veux tu le continuer ou bien le refaire au dbut?", "Reprise de l'exercice",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE,null, options, options[0]);
		   if (n1 == JOptionPane.YES_OPTION){ 
		       inter(numquestion);
		   }   
		   else{
		       inter(0);
		   }
	       }
	   }
       }
      
  public void smile(){
	 if(nbClick<=nbClickAvant){
	     labelSmile.setIcon(iconSmile);
	 }
	 else{
	     labelSmile.setIcon(iconNotSmile);
	 }
     }
     public void inter(int num){
	 numero=num;
	 bouton.removeActionListener(e);
	 pane.removeAll();
	 pane.add(sortie,null);
	 labelSmile = new JLabel(iconSmile);
	 labelSmile.setBounds(new Rectangle(868,0,115,100));
	 pane.add(labelSmile,null);
	 targetModel.removeAllElements();
	 sourceModel.removeAllElements();
	 System.out.println("numero"+numero);
	 exo1 = (StructExoReconnaissance1)tabQuestion.get(numero);
	 icon = new ImageIcon(exo1.getUrlImage());
	 image = new JLabel(icon);
	 panelReponse = getListPanel(sourceList, sourceModel);
	 //la consigne
	 pane.add(enonce,null);
	 enonce.setBackground(new Color (211, 32, 47));
  	 enonce.setFont(new java.awt.Font("Arial", 1, 35));
  	 enonce.setForeground(new Color (209, 224, 104));
  	 enonce.setText(exo1.getConsigne());
  	 enonce.setBounds(new Rectangle(60, 10, 1000, 50));
	 
	
	  //Les propositions
	 for (Iterator i = exo1.getDonnees_propositions().iterator(); i.hasNext(); ){
	     String prop=(i.next()).toString();
	     targetModel.addElement(prop);
	 } 


	 int k=targetModel.size();
	 cpt=0;
	 for(Enumeration i = targetModel.elements(); i.hasMoreElements(); ){
	     int no=(int)((k)* Math.random());
	     if(no>=k){
		 no=k-1;
	     }
	     if(no<0){
		 no=0;
	     }
	  
	     String s= i.nextElement().toString();
	     int pos=targetModel.indexOf(s);
	     String s1 = targetModel.get(no).toString();
	     int pos1=targetModel.indexOf(s1);
	     targetModel.set(pos,s1);
	     targetModel.set(pos1,s);
	     
	 }





	 panelPropositions = getListPanel(targetList, targetModel);
	 pane.add(panelPropositions,null);
	 
	 pane.add(bouton, null);
	 pane.add(image, null);
	 pane.add(panelReponse,null);
  
	 bouton.setBounds(new Rectangle(700, 560, 90, 70));
	 bouton.setFont(new java.awt.Font("Arial", 1, 35));
  	 image.setBounds(new Rectangle(100, 150, 400, 350));
	 image.setBackground(new Color (211, 32, 47));
	 panelReponse.setBounds(new Rectangle (75, 550, 450, 70));
	 panelPropositions.setBounds(new Rectangle (600, 125, 350, 400));
	 panelPropositions.setBackground(new Color (249, 157, 28));
	 pane.setBackground(new Color (211, 32, 47));

	 //le listener du bouton
	 e = new ActionListener(){
		 public void actionPerformed(ActionEvent e){
		     cptClick++;
		     if(sourceModel.isEmpty()){
			 JOptionPane.showMessageDialog(fenetre,"Tu as rien lis dans la case!");
			 nbClick++;
			 smile();
			 
		     }
		     else{		     
			 if(exo1.getReponse().equals(sourceModel.get(0))){
			     if(nbClick==0){
				  JOptionPane.showMessageDialog(fenetre,"Bravo, et du premier coup!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
			      }
			      else{
				  JOptionPane.showMessageDialog(fenetre,"Bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
			      }
			      nbClickAvant=nbClick;
			      if(nbClick!=0){
			      nbClickTotal+=nbClick;
			      }
			      nbClick=0;
 
			     numero+=1;
			     if(numero==nbQuestion){
				 if(nbClickTotal==0){
				     JOptionPane.showMessageDialog(fenetre, "Tu as russsi l'exercice sans faire aucune faute, bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
				  }
				  else{
				      JOptionPane.showMessageDialog(fenetre, "Tu as russsi l'exercice, bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
				  }	
				 etudiant.modifieHistorique("|reconnaissance|"+nomExercice+"_"+niveau,""+nbQuestion);
				
				 double a = ((double)(nbQuestionRep+1)/(double)cptClick)*100;
				 reussite = (int)a;
				 mouchard.insertData("|reconnaissance|"+nomExercice+"_"+niveau,nomExercice,1,reussite,1);

				 fenetre.dispose();
			     }
			     else{
				 inter(numero);
				 nbQuestionRep++;
			     }
			 }
			 else{
			     JOptionPane.showMessageDialog(fenetre,"Regardes bien, ce n'est pas le bon choix!","Erreur",JOptionPane.INFORMATION_MESSAGE,iconNotSmile);
			     nbClick++;
			     smile(); 
			     for (Enumeration enum = sourceModel.elements(); enum.hasMoreElements(); ){
				 targetModel.addElement(enum.nextElement());
			     }
			     sourceModel.removeAllElements();
			 }
		     }
		 }
	     };
	 bouton.addActionListener(e);	
	 pane.repaint();	   
	 fenetre.show();
     }
   
     
     public static void main(String[] arguments) {
	 ExoReconnaissance1 exo = new ExoReconnaissance1("testexo.txt",new Espion("robert"), new Eleve("test"));
	 exo.reader();
	 exo.inter(0);
    }
     
  private JPanel getListPanel(DNDList list, DefaultListModel listModel ){ 
        JPanel listPanel = new JPanel();
        JScrollPane scrollPane = new JScrollPane(list);
	       
        list.setModel(listModel);  
        listPanel.setLayout( new BorderLayout());
        listPanel.add( scrollPane, BorderLayout.CENTER);
	list.setBackground(new Color(249, 157, 28));
	list.setFont(new java.awt.Font("Arial", 1, 40));
	list.setForeground(new Color(0, 120, 73));
        return listPanel;     
  }
 }
