
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Menu;
import java.io.*;
import java.util.StringTokenizer;
import java.util.*;


class Modification{
  
    String[] listFichier;
    File rep;
    int nb=0;
    ActionListener eventOrth;
    ActionListener eventReconnaissance;
    ActionListener eventDrag;
    String[][] mesIntituleListenerdrag;
    String[][] mesIntituleListenerorth;
    String[][] mesIntituleListenerreconnaissance;
    JFrame fenetre;
    JPanel panelHaut;
    JPanel panelBas;
    JLabel titre;
    JComboBox listeDrag;
    JComboBox listeOrth;
    JComboBox listeReconnaissance;
    JButton boutonDrag;
    JButton boutonReconnaissance;
    JButton boutonOrth;
    JLabel intituleDrag = new JLabel("Reprage");
    JLabel intituleReconnaissance = new JLabel("Image");
    JLabel intituleOrth = new JLabel("Orthographe");
    ImageIcon iconDrag = new ImageIcon("arbre01.gif");
    ImageIcon iconReconnaissance = new ImageIcon("sun10.gif");
    ImageIcon iconOrth = new ImageIcon("iconeorth.gif");
    
    String ligneTitre;
    String ligneUrl;
    String ligneNiveau;
    Educatemps inter;
    public Modification(Educatemps i){
	inter=i;
	fenetre = new JFrame("Modifications d'exercices");
	panelHaut = new JPanel();
	panelBas = new JPanel();
	
	panelHaut.setLayout(null);
	panelBas.setLayout(null);
	panelHaut.setPreferredSize(new Dimension(600, 100));

	listeDrag = new  JComboBox();
	listeReconnaissance = new  JComboBox();
	listeOrth = new  JComboBox();
	boutonDrag = new JButton("",iconDrag);
	boutonReconnaissance = new JButton("",iconReconnaissance);
	boutonOrth = new JButton("",iconOrth);
	titre = new JLabel("Modifications d'exercices");
	titre.setBounds(new Rectangle(350,0, 450,50));
	titre.setFont(new java.awt.Font("Arial", 1, 25));
	titre.setForeground(Color.red);
	panelHaut.add(titre);
        
	boutonReconnaissance.setBounds(new Rectangle(150, 150, 100, 100));
	boutonOrth.setBounds(new Rectangle(550, 150, 100, 100));
	boutonDrag.setBounds(new Rectangle(300, 300, 100, 100));
	
	listeReconnaissance.setBounds(new Rectangle(250,190, 200, 30));
	listeOrth.setBounds(new Rectangle(650, 190, 200, 30));
	listeDrag.setBounds(new Rectangle(400, 340, 300, 30));

	listeReconnaissance.setBackground(Color.white);
	listeOrth.setBackground(Color.white);
	listeDrag.setBackground(Color.white);

	intituleReconnaissance.setBounds(new Rectangle(250,150, 200, 40));
	intituleOrth.setBounds(new Rectangle(650, 150, 200, 40));
	intituleDrag.setBounds(new Rectangle(400, 300, 300, 40));
	intituleDrag.setFont(new java.awt.Font("Arial", 1, 25));
	intituleOrth.setFont(new java.awt.Font("Arial", 1, 25));
	intituleReconnaissance.setFont(new java.awt.Font("Arial", 1, 25));
	intituleDrag.setForeground(Color.black);
	intituleOrth.setForeground(Color.black);
	intituleReconnaissance.setForeground(Color.black);


	panelBas.add(boutonReconnaissance,null);
	panelBas.add(boutonDrag,null);
	panelBas.add(boutonOrth,null);
	panelBas.add(intituleReconnaissance,null);
	panelBas.add(intituleDrag,null);
	panelBas.add(intituleOrth,null);
	panelBas.add(listeOrth,null);
	panelBas.add(listeReconnaissance,null);
	panelBas.add(listeDrag,null);
	fenetre.setSize(1024,768);
	fenetre.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    fenetre.dispose();
		}
	    }
				  );
	fenetre.addWindowListener(new WindowAdapter(){
		public void windowIconified(WindowEvent e){
		    
		}
	    }
				);
	fenetre.getContentPane().add("North",panelHaut);
	fenetre.getContentPane().add("Center",panelBas);
	fenetre.show();   
    }
    
    public void modifie(){
	listeReconnaissance.removeAllItems();
	listeDrag.removeAllItems();
	listeOrth.removeAllItems();
	boutonReconnaissance.removeActionListener(eventReconnaissance);
	boutonOrth.removeActionListener(eventOrth);
	boutonDrag.removeActionListener(eventDrag);
	listeReconnaissance.insertItemAt("Choisir l'exercice",0);
	listeOrth.insertItemAt("Choisir l'exercice",0);
	listeDrag.insertItemAt("Choisir l'exercice",0);
	listeReconnaissance.setSelectedIndex(0);
	listeOrth.setSelectedIndex(0);
	listeDrag.setSelectedIndex(0);
	

	rep = new File("exercice/drag");
	listFichier = rep.list();
	nb=listFichier.length;  
	mesIntituleListenerdrag= new String[nb+1][3];
	for(int i=0; i<listFichier.length; i++){
	    try{ 		
		BufferedReader fichierexo = new BufferedReader(new FileReader("exercice/drag/"+listFichier[i]));
		ligneTitre=fichierexo.readLine();
		ligneUrl=fichierexo.readLine();
		ligneNiveau=fichierexo.readLine();
		listeDrag.insertItemAt(ligneTitre+" ("+ligneNiveau+")",i+1);
		mesIntituleListenerdrag[i+1][0]=ligneUrl;
		mesIntituleListenerdrag[i+1][1]=ligneNiveau;
		mesIntituleListenerdrag[i+1][2]=ligneTitre;
	    }
	    catch(FileNotFoundException err)
		{
		    System.err.println("Fichier non trouve !\n");
		    System.err.println(err);
		}
	    catch(IOException err)
		{
		    System.err.println("Erreur d'IO\n");
		    System.err.println(err);
		}
	}

	rep = new File("exercice/orth");
	listFichier = rep.list();
	nb=listFichier.length;  
	mesIntituleListenerorth= new String[nb+1][3];
	for(int i=0; i<listFichier.length; i++){
	    try{ 		
		BufferedReader fichierexo = new BufferedReader(new FileReader("exercice/orth/"+listFichier[i]));
		ligneTitre=fichierexo.readLine();
		ligneUrl=fichierexo.readLine();
		ligneNiveau=fichierexo.readLine();
		listeOrth.insertItemAt(ligneTitre+" ("+ligneNiveau+")",i+1);
		mesIntituleListenerorth[i+1][0]=ligneUrl;
		mesIntituleListenerorth[i+1][1]=ligneNiveau;
		mesIntituleListenerorth[i+1][2]=ligneTitre;
	    }
	    catch(FileNotFoundException err)
		{
		    System.err.println("Fichier non trouve !\n");
		    System.err.println(err);
		}
	    catch(IOException err)
		{
		    System.err.println("Erreur d'IO\n");
		    System.err.println(err);
		}
	}
	
		
	rep= new File("exercice/reconnaissance");
	listFichier=rep.list();
	nb=listFichier.length;  
	System.out.println(nb);
	mesIntituleListenerreconnaissance = new String[nb+1][3];
	for(int i=0; i<listFichier.length; i++){
	    try{ 		
		BufferedReader fichierexo = new BufferedReader(new FileReader("exercice/reconnaissance/"+listFichier[i]));
		ligneTitre=fichierexo.readLine();
		ligneUrl=fichierexo.readLine();
		ligneNiveau=fichierexo.readLine();
		listeReconnaissance.insertItemAt(ligneTitre+" ("+ligneNiveau+")",i+1);
		mesIntituleListenerreconnaissance[i+1][0]=ligneUrl;
		mesIntituleListenerreconnaissance[i+1][1]=ligneNiveau;
		mesIntituleListenerreconnaissance[i+1][2]=ligneTitre;
	    }
	    catch(FileNotFoundException err)
		{
		    System.err.println("Fichier non trouve !\n");
		    System.err.println(err);
		}
	    catch(IOException err)
		{
		    System.err.println("Erreur d'IO\n");
		    System.err.println(err);
		}
	}

	//le drags and drops avec du texte (reprage)************************************************************
	eventDrag = new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    if(listeDrag.getSelectedIndex()==0){
			JOptionPane.showMessageDialog(fenetre,"Vous devez choisir un exercice");
		    }
		    else{
			String nomexo = mesIntituleListenerdrag[listeDrag.getSelectedIndex()][0];
			String nomCle = mesIntituleListenerdrag[listeDrag.getSelectedIndex()][2];
			String niv = mesIntituleListenerdrag[listeDrag.getSelectedIndex()][1];
			ModifDrag m= new ModifDrag(nomexo,inter);
			m.reader();
			m.inter(0);			    
			}
		    }
		
	    };
	boutonDrag.addActionListener(eventDrag);
	
	
	eventOrth = new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    if(listeOrth.getSelectedIndex()==0){
			JOptionPane.showMessageDialog(fenetre,"Vous devez choisir un exercice");
		    }
		    else{
			String nomexo = mesIntituleListenerorth[listeOrth.getSelectedIndex()][0];
			String niv = mesIntituleListenerorth[listeOrth.getSelectedIndex()][1];
			String nomCle = mesIntituleListenerorth[listeOrth.getSelectedIndex()][2];
			ModifOrth m1= new ModifOrth(nomexo, inter);
			m1.reader();
			m1.inter(0);			    

			}
		    }
		
	    };
	boutonOrth.addActionListener(eventOrth);
	
	
	//le drags and drops avec image************************************************************
	
	eventReconnaissance = new ActionListener(){
    		public void actionPerformed(ActionEvent e){
		    if(listeReconnaissance.getSelectedIndex()==0){
			JOptionPane.showMessageDialog(fenetre,"Vous devez choisir un exercice");
		    }
		    else{
			String nomexo = mesIntituleListenerreconnaissance[listeReconnaissance.getSelectedIndex()][0];
			String nomCle=mesIntituleListenerreconnaissance[listeReconnaissance.getSelectedIndex()][2];
			String niv=mesIntituleListenerreconnaissance[listeReconnaissance.getSelectedIndex()][1];
			ModifReconnaissance m2= new ModifReconnaissance(nomexo, inter);
			m2.reader();		
			m2.inter(0);	


			}
		    }
		
	    };
	boutonReconnaissance.addActionListener(eventReconnaissance);
	panelBas.repaint();
	listeReconnaissance.revalidate();
	listeDrag.revalidate();
	listeOrth.revalidate();
    }

   
    public static void main(String[] args){
	Modification e = new Modification(new Educatemps());
	e.modifie();

    }
}
