import java.util.*; 
import java.io.*; 

public class PropsHandler { 
    
    public PropsHandler() { 
    } 
    
    public Properties loadProps(String filePath){ 
        Properties props = null; 
        try{ 
            props = new Properties(); //cr une property
            props.load(new FileInputStream(filePath)); //charge le fichier contenant les valeurs
        }catch(FileNotFoundException fnfe){ 
	    
        }
	catch(Exception e){ 
        }
	finally{ 
            return props; 
        } 
    } 
    
    public boolean storeProps(String filePath, Properties newProps){  //permet de mettre  jour notre fichier une fois la property modifie
        boolean isStored = false; 
        try{ 
            OutputStream out = new FileOutputStream(filePath); 
            newProps.store(out, getHeader()); 
        }
	catch(Exception e){ 
        }
	finally{ 
            return isStored; 
        } 
    } 
    
    private String getHeader(){ 
        return "Fichier de config pour utilisateur ..."; 
    } 

    public static void main (String args[]) { 
        PropsHandler handler = new PropsHandler(); 
        String propertiesFilePath = "C:/tmp/config.cfg"; 
        Properties props = handler.loadProps(propertiesFilePath); 
        props.put("MAX_CONNECTIONS","45"); 
        props.put("USER_ID","G5248TT"); 
        props.put("test","ca marche");
	props.setProperty("test","ca marche encore meiux");
	handler.storeProps(propertiesFilePath,props); 
        System.out.println("Termin!"); 
    } 
} 





