
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Menu;
import java.io.*;
import java.util.StringTokenizer;
import java.util.*;


class SupprimeUtilisateur{
    Educatemps inte;
    String[] listFichier;
    File rep;
    int nb=0;
    ActionListener event;
    JFrame fenetre;
    JPanel panelHaut;
    JPanel panelBas;
    JLabel titre;
    JComboBox listeEleve;
    JButton boutonSupprime;
    JLabel intitule = new JLabel("Liste des lves");
    ImageIcon icon = new ImageIcon("supprime.gif");
    String[][] utilisateurs;
    String nomUser;

    public SupprimeUtilisateur(String nom, Educatemps edu){
	inte = edu;
	nomUser=nom;
	fenetre = new JFrame("Suppression d'un utilisateur");
	panelHaut = new JPanel();
	panelBas = new JPanel();
	
	panelHaut.setLayout(null);
	panelBas.setLayout(null);
	panelHaut.setPreferredSize(new Dimension(600, 100));

	listeEleve = new  JComboBox();
	boutonSupprime = new JButton("",icon);
	
	titre = new JLabel("Suppression d'un utilisateur");
	titre.setBounds(new Rectangle(350,0, 350,50));
	titre.setFont(new java.awt.Font("Arial", 1, 25));
	titre.setForeground(Color.red);
	panelHaut.add(titre);
        
	
	boutonSupprime.setBounds(new Rectangle(300, 200, 100, 100));
	listeEleve.setBounds(new Rectangle(400, 240, 300, 30));

	listeEleve.setBackground(Color.white);
	
	intitule.setBounds(new Rectangle(400, 200, 300, 40));
	intitule.setFont(new java.awt.Font("Arial", 1, 25));
	intitule.setForeground(Color.black);
	

	panelBas.add(boutonSupprime,null);
	panelBas.add(intitule,null);
	panelBas.add(listeEleve,null);
	fenetre.setSize(1024,768);
	fenetre.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    inte.creeListeUtilisateur();
		    fenetre.dispose();
		}
	    }
				  );
	fenetre.addWindowListener(new WindowAdapter(){
		public void windowIconified(WindowEvent e){
		    
		}
	    }
				);
	fenetre.getContentPane().add("North",panelHaut);
	fenetre.getContentPane().add("Center",panelBas);
	fenetre.show();   
    }
 

    public void creeListeUtilisateur(){
	listeEleve.removeAllItems();
	boutonSupprime.removeActionListener(event);
	listeEleve.insertItemAt("Choisir l'utilisateur",0);
	listeEleve.setSelectedIndex(0);
	rep = new File("usersdata");
	String[] listFichier = rep.list();
	int nb=listFichier.length;  
	utilisateurs = new String[nb][2];
	for(int i=0; i<listFichier.length; i++){
	    String s = listFichier[i];
	    PropsHandler handler = new PropsHandler(); 
	    String propertiesFilePath = "usersdata/"+s; 
	    Properties props = handler.loadProps(propertiesFilePath); 
	    String nom=props.getProperty("NOM"); 
	    String prenom=props.getProperty("PRENOM"); 
	    listeEleve.insertItemAt(nom+" "+prenom,i+1);
	}

	event = new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    if(listeEleve.getSelectedIndex()==0){
			JOptionPane.showMessageDialog(fenetre,"Vous devez choisir un lve");
		    }
		    else{
			int i = JOptionPane.showConfirmDialog(fenetre, "Etes vous sr de vouloir supprimer ce fichier?","Suppression?",JOptionPane.YES_NO_OPTION);
			if (i == JOptionPane.YES_OPTION){
			    if(listeEleve.getSelectedItem().equals(nomUser)){
				JOptionPane.showMessageDialog(fenetre,"Cette lve a sa session ouverte, veuillez fermer sa session");
			    }
			    else{String url = listeEleve.getSelectedItem()+".txt";
			    File f = new File("usersdata/"+url);
			    f.delete();
			    creeListeUtilisateur();
			    }
			}
		    }
		}
	    };
	boutonSupprime.addActionListener(event);
	panelBas.revalidate();
	panelBas.repaint();
    }
    
    public static void main(String[] args){
	SupprimeUtilisateur e = new SupprimeUtilisateur("robert", new Educatemps());
	e.creeListeUtilisateur();
	
    }
}
