import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import java.util.StringTokenizer;


public class ExerciceDrag extends Exercice{
    String niveau;
    int nbQuestion;
    Vector[] donnees_vide;
    Vector[] donnees_propositions;
    Vector[] donnees_label;
    String consigne;
    int nbCases;
    String[] donnees_reponses;
    int nbCasesVides;
    Vector tabQuestion = new Vector();
    String nomExercice;
    int cpt2=0;
    public ExerciceDrag(String url, Espion e, Eleve etu){
	super(url,e,etu);
    try{
	     BufferedReader fichierexo = new BufferedReader(new FileReader("exercice/drag/"+urlExercice));
	     String ligne;
	     StringTokenizer line;
	     nomExercice=fichierexo.readLine();
	 }
	 catch(FileNotFoundException err)
	     {
		 System.err.println("Fichier non trouve !\n");
		 System.err.println(err);
	     }
	  catch(IOException err)
	      {
		  System.err.println("Erreur d'IO\n");
		  System.err.println(err);
	      } 
    } 
    
    public void reader(){
	try{
	    BufferedReader fichierexo = new BufferedReader(new FileReader("exercice/drag/"+urlExercice));
	    String ligne;
	    StringTokenizer line;
	    fichierexo.readLine();
	    fichierexo.readLine();
	    niveau=fichierexo.readLine();
	    String n = fichierexo.readLine();
	    System.out.println("nombre de question : "+n);
	    nbQuestion=(new Integer(n)).intValue();
	    donnees_vide=new Vector[nbQuestion];
	    donnees_label=new Vector[nbQuestion];
	    donnees_propositions=new Vector[nbQuestion];
	    
	    for(int i=0; i<nbQuestion; i++){
		donnees_vide[i]=new Vector();
		donnees_label[i]=new Vector();
		donnees_propositions[i]=new Vector();
		//donnees_reponses[i]=new Vector();
	    }
	    
	    while((ligne = fichierexo.readLine()) != null){
		if(!(ligne.equals("////"))){
		    consigne = ligne;
		    //le nombre de label
		    nbCases= (new Integer(fichierexo.readLine())).intValue();
		    donnees_reponses = new String[nbCases+1];
		     nbCasesVides =(new Integer(fichierexo.readLine())).intValue();
		     //les numeros des labels vides
		     ligne=fichierexo.readLine();
		     line = new StringTokenizer(ligne,";");
		     while(line.hasMoreTokens()){		
			 String numeroVide = line.nextToken(); //(new Integer(line.nextToken())).intValue();
			 donnees_vide[cpt2].add(numeroVide);
		     }
		     
		     //les labels dj remplis
		     ligne=fichierexo.readLine();
		     line = new StringTokenizer(ligne,";");
		     while(line.hasMoreTokens()){
			 String nomLabel = line.nextToken();	
			 String numeroLabel = line.nextToken(); //(new Integer(line.nextToken())).intValue();
			 donnees_label[cpt2].add(numeroLabel);
			 donnees_label[cpt2].add(nomLabel);
		     }
		     
		     //la liste des propositions
		     ligne=fichierexo.readLine();
		     line = new StringTokenizer(ligne,";");
		     while(line.hasMoreTokens()){
			 String proposition= line.nextToken();	
			 donnees_propositions[cpt2].add(proposition);
		     }
		     
		     //les rponses
		     ligne=fichierexo.readLine();
		     line = new StringTokenizer(ligne,";");
		     while(line.hasMoreTokens()){
			 String nomReponse = line.nextToken();	
			 int numeroReponse =(new Integer(line.nextToken())).intValue();
			 donnees_reponses[numeroReponse]=nomReponse;
		     }
		 }
		 else{
		     tabQuestion.add(new StructExoDrag1(consigne,nbCases,nbCasesVides,donnees_vide[cpt2], donnees_label[cpt2], donnees_propositions[cpt2],donnees_reponses));
		     cpt2++;

		 }
	     }
	 }
	 catch(FileNotFoundException err)
	     {
		 System.err.println("Fichier non trouve !\n");
		 System.err.println(err);
	     }
	 catch(IOException err)
	     {
		 System.err.println("Erreur d'IO\n");
		 System.err.println(err);
	     }
    }


    public void reprise(){}
    public void inter(int num){}
    public void smile(){}
}
