import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import java.util.StringTokenizer;



 public class ExoDrag2 extends ExerciceDrag{ 
   
     ActionListener e;
     Frame fenetre;
     String nomUtilisateur;
     StructExoDrag1 exo2;
     int numero=0;
     JLabel[] mesLabels;             //le tableau des labels
     JTextField[] mesPanelsReponses;     //les panels ou vont les rponses
     int nbClick=0;
     int nbClickAvant=0;
     int nbClickTotal=0;
     JLabel enonce = new JLabel();
     int y =120;
     int cpt;
     int cpt2=0;
  
     JPanel pane;
     JButton bouton = new JButton ("OK");
     JTable tablePropositions;
 
     ImageIcon iconSortie = new ImageIcon("sortie.gif");
     JButton sortie = new JButton("",iconSortie);
   
     String niveau;
     ImageIcon iconSmile = new ImageIcon("smiley.jpg");
     ImageIcon iconNotSmile = new ImageIcon("smileynot.jpg");
     JLabel labelSmile;
   
     int cptClick=0;
     int reussite=0;
     int nbQuestionRep=0;
   

     public ExoDrag2(String urlExo,  Espion e, Eleve etu) {
	super(urlExo,e,etu);
 nomUtilisateur = getEleve().getNom();


	 fenetre = new Frame("Reprage : niveau intermdiaire");
	 pane = new JPanel();
	 pane.setLayout(null);
	 pane.setBackground(new Color (91, 87, 166));
	 fenetre.add(pane);
	 fenetre.addWindowListener(new WindowAdapter(){
		 public void windowClosing(WindowEvent e){
		     Object[] options = { "Quitter", "Annuler" };
		     int i= JOptionPane.showOptionDialog(fenetre, "Tu es sr de quitter, dans ce cas on enregistre ton travail", "Quitter?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);
		     if (i == JOptionPane.YES_OPTION){ 
			String numquestfin = ""+numero;
			
			etudiant.modifieHistorique("|drag|"+nomExercice+"_"+niveau,""+numquestfin);
			if(nbQuestionRep>0){
			     double a = ((double)nbQuestionRep/(double)cptClick)*100;
			     reussite = (int)a;
			     mouchard.insertData("|drag|"+nomExercice+"_"+niveau,nomExercice,2,reussite,0);
			 }


			fenetre.dispose();
		    }

		 }
	     }
				   );
	 fenetre.setSize(1024,768);
	 
     }
  
    public void reprise(){
	   sortie.setBounds(new Rectangle(0,0,50, 20));
	   sortie.addActionListener(new ActionListener(){
		   public void actionPerformed(ActionEvent e){   
		       Object[] options = { "Quitter", "Annuler" };
		       int i= JOptionPane.showOptionDialog(fenetre, "Tu es sr de quitter, dans ce cas on enregistre ton travail", "Quitter?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);

   
		       if (i == JOptionPane.YES_OPTION){ 
			   String numquestfin = ""+numero;
			  
			   etudiant.modifieHistorique("|drag|"+nomExercice+"_"+niveau,numquestfin);
			   if(nbQuestionRep>0){
			     double a = ((double)nbQuestionRep/(double)cptClick)*100;
			     reussite = (int)a;
			     mouchard.insertData("|drag|"+nomExercice+"_"+niveau,nomExercice,2,reussite,0);
			 }


			   fenetre.dispose();
		       }
		     
		   }
	       }
				    );


	   String rep = etudiant.litHistorique("|drag|"+nomExercice+"_"+niveau,"");
	
	   
	   if((rep.equals(""))||(rep.equals("0"))){
	       inter(0);
	   }
	   else{
	       int numquestion = (new Integer(rep)).intValue();
	       if(numquestion==nbQuestion){
		   Object[] options = { "Oui", "Non" };
		   int n= JOptionPane.showOptionDialog(fenetre, "Tu as dj fait cet exercice et tu l'as fini, veux tu le refaire?", "Reprise?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);

		   if (n == JOptionPane.YES_OPTION){ 
		       inter(0);
		   }
		   else{
		       fenetre.dispose();	   
		   }
	       }
	       else{
		   Object[] options = { "Reprendre", "Recommencer au dbut" };
		   int n1 = JOptionPane.showOptionDialog(fenetre, "Tu as dj commenc cet exercice, veux tu le continuer ou bien le refaire au dbut?", "Reprise de l'exercice",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE,null, options, options[0]);
	  
		   if (n1 == JOptionPane.YES_OPTION){ 
		       System.out.println("reprise a "+rep);
		       inter(numquestion);
		   }   
		   else{
		       inter(0);
		   }
	       }
	   }
       }
      
   
     public void smile(){
	 if(nbClick<=nbClickAvant){
	     labelSmile.setIcon(iconSmile);
	 }
	 else{
	     labelSmile.setIcon(iconNotSmile);
	 }
     }


     public void inter(int num){
	 bouton.removeActionListener(e);
	 pane.removeAll();
	 pane.add(sortie,null);
	 labelSmile = new JLabel(iconSmile);
	 labelSmile.setBounds(new Rectangle(868,0,115,100));
	 pane.add(labelSmile,null);
	 numero = num;
	 exo2 = (StructExoDrag1)tabQuestion.get(numero);
	 nbCases = exo2.getNbCases();
	 mesLabels = new JLabel[nbCases+1];
	 mesPanelsReponses = new JTextField[nbCases+1];
	 for(int i=0; i<nbCases+1; i++){
	     if(mesPanelsReponses[i]!=null){
	     mesPanelsReponses[i].setText("");
	     }
	 }
	 String[][] data = new String[exo2.getDonnees_propositions().size()][1];
	 String[] nomColonne = new String[1];
	 nomColonne[0]="Les propositions";
	 
	 pane.add(enonce,null);
	  enonce.setBackground(new Color (91, 87, 166));
  	 enonce.setFont(new java.awt.Font("Arial", 1, 35));
  	 enonce.setForeground(new Color (235, 232, 71));
  	 enonce.setText(exo2.getConsigne());
  	 enonce.setBounds(new Rectangle(70, 10, 1000, 50));
	 	 
	
	  //Les propositions




	 int k=0;
	 for (Iterator i = exo2.getDonnees_propositions().iterator(); i.hasNext(); ){
	     String prop=(i.next()).toString();
	     data[k][0]=prop;
	     k++;
	 } 
	 int k1=data.length;
	 cpt=0;
	 for(int i =0; i<k1; i++ ){
	     int no=(int)((k1)* Math.random());
	     if(no>=k1){
		 no=k1-1;
	     }
	     if(no<0){
		 no=0;
	     }
	  
	     String s= data[i][0];
	     int pos=i;
	     String s1 = data[no][0];
	     int pos1=no;
	     data[pos][0]=s1;
	     data[pos1][0]=s;
	     
	 }





	 tablePropositions = new JTable(data, nomColonne);
	 tablePropositions.setFont(new java.awt.Font("Arial", 1, 40));
	 tablePropositions.setForeground(new Color(116, 38, 114));
	 tablePropositions.setBackground(new Color(153, 198, 234));
	 tablePropositions.setRowHeight(70);
	 JScrollPane scroll =  new JScrollPane(tablePropositions);
	 //Les propositions
	 scroll.setBounds(new Rectangle (550, 120, 300, 450));
	 scroll.setBackground(new Color(153, 198, 234));
	 pane.add(scroll,null);

	 //Les labels remplis et vide
	 for (Iterator i = exo2.getDonnees_label().iterator(); i.hasNext(); ){
	     int n = (new Integer((i.next()).toString())).intValue();
	     String intitule = (i.next()).toString();
	     mesLabels[n] = new JLabel(intitule);
	 }
	 
	
	 for (int i=1; i<=nbCases; i++ ){
	     if((exo2.getDonnees_reponses())[i]!=null){
		 String intitule = (exo2.getDonnees_reponses())[i];
		 mesPanelsReponses[i] = new JTextField(50);
		 mesPanelsReponses[i].setFont(new java.awt.Font("Arial", 1, 40));
		  }
	  }

	  for(int i=1; i<=nbCases; i++){
	      if(mesLabels[i]==null){
		  pane.add(mesPanelsReponses[i],null);
		  mesPanelsReponses[i].setBounds(new Rectangle(120, y, 270, 70));
		  mesPanelsReponses[i].setBackground(new Color(153, 198, 234));
		  mesPanelsReponses[i].setForeground(new Color(116, 38, 114));
	      }
	      else{
		  pane.add(mesLabels[i],null);
		  mesLabels[i].setBounds(new Rectangle(150, y, 250, 70));
		  mesLabels[i].setFont(new java.awt.Font("Arial", 1, 40));
		  mesLabels[i].setForeground(new Color (254, 192, 15));
	     }
	      y+=80;	
	  }
	  y=120;
	
	  e = new ActionListener(){
		  public void actionPerformed(ActionEvent e){
		      cptClick++;
		      boolean rep=false;
		      boolean suite=false;
		      for (Iterator i = exo2.getDonnees_vide().iterator(); i.hasNext(); ){
			  int num2=(new Integer((i.next()).toString())).intValue();
			  if(mesPanelsReponses[num2].getText().equals("")){
			      suite=false;	
			      break;
			  }
			  else{
			      suite=true;
			  }
		      }
		      if(!suite){
			 JOptionPane.showMessageDialog(fenetre,"Toutes les cases ne sonr pas remplies!");
			 nbClick++;
			 smile();
		      }
		      else{
			  for (Iterator i = exo2.getDonnees_vide().iterator(); i.hasNext(); ){
			      int num=(new Integer((i.next()).toString())).intValue();
			      if((exo2.getDonnees_reponses())[num].equals(mesPanelsReponses[num].getText())){
				  rep=true;
			      }
			      else{
				  rep=false;
				  break;
			      }
			  }
			  if(rep){
			      if(nbClick==0){
				  JOptionPane.showMessageDialog(fenetre,"Bravo, et du premier coup!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
			      }
			      else{
				  JOptionPane.showMessageDialog(fenetre,"Bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
			      }
			      nbClickAvant=nbClick;
			      if(nbClick!=0){
			      nbClickTotal+=nbClick;
			      }
			      nbClick=0;
			       
			      int j=numero+1;			      
			      if(j==nbQuestion){
				  if(nbClickTotal==0){
				      JOptionPane.showMessageDialog(fenetre, "Tu as russsi l'exercice sans faire aucune faute, bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
				  }
				  else{
				      JOptionPane.showMessageDialog(fenetre, "Tu as russsi l'exercice, bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
				  }	
				  etudiant.modifieHistorique("|drag|"+nomExercice+"_"+niveau,""+nbQuestion);
				  double a = ((double)(nbQuestionRep+1)/(double)cptClick)*100;
				  reussite = (int)a;
				  mouchard.insertData("|drag|"+nomExercice+"_"+niveau,nomExercice,2,reussite,1);
				  fenetre.dispose();
				  
			      }
			      else{
				  inter(j);
				  nbQuestionRep++;
			      }
			  }
			  else{
			      JOptionPane.showMessageDialog(fenetre,"Regardes bien, ce n'est pas le bon choix!","Erreur",JOptionPane.INFORMATION_MESSAGE,iconNotSmile);
			      nbClick++;
			      for(int i =1; i<=nbCases; i++){
				  if(mesPanelsReponses[i]!=null){
				      mesPanelsReponses[i].setText("");
				  }
			      }
				      smile();
				  }
		      }
		  }
	      };
	      bouton.addActionListener(e);		   
			

	 pane.add(bouton,null);
	 bouton.setBounds(new Rectangle(900, 600, 90, 70));
	 bouton.setFont(new java.awt.Font("Arial", 1, 35));
	 pane.repaint();
	 fenetre.show();
     }


      public static void main(String[] arguments) {
	ExoDrag2 exo = new ExoDrag2("Les jours de la semaine.txt", new Espion("Charles Foulon"), new Eleve("test"));
	exo.reader();
	exo.reprise();
	//exo.inter(0);
      }
 }
