import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import java.util.StringTokenizer;

 public class ExoReconnaissance3 extends ExerciceReconnaissance{
    
     int nbClick=0;
     int nbClickAvant=0;
     int nbClickTotal=0;
     ImageIcon iconSmile = new ImageIcon("smiley.jpg");
     ImageIcon iconNotSmile = new ImageIcon("smileynot.jpg");
     JLabel labelSmile;
     StructExoReconnaissance1 exo1;
     ActionListener e;
     Frame fenetre;
     String nomUtilisateur;
   
     int numero;
   
     JLabel enonce = new JLabel ();
     ImageIcon icon;
     JLabel image;
     JPanel pane;
     JButton bouton = new JButton ("OK");
     JTable tablePropositions;
     JTextField labelReponse = new JTextField(50);
   
     ImageIcon iconSortie = new ImageIcon("sortie.gif");
     JButton sortie = new JButton("",iconSortie);
     String nomExercice;
    
     int cptClick=0;
     int reussite=0;
     int nbQuestionRep=0;
    

     public ExoReconnaissance3(String urlExo, Espion e, Eleve etu) {
 super(urlExo,e,etu);
	
	  fenetre = new Frame("Images : niveau difficile");
	  fenetre.setSize(1024, 768);
	  fenetre.addWindowListener(new WindowAdapter(){
		  public void windowClosing(WindowEvent e){
		      Object[] options = { "Quitter", "Annuler" };
		     int i= JOptionPane.showOptionDialog(fenetre, "Tu es sr de quitter, dans ce cas on enregistre ton travail", "Quitter?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);
		     if (i == JOptionPane.YES_OPTION){ 
			 String numquestfin = ""+numero;
			 etudiant.modifieHistorique("|reconnaissance|"+nomExercice+"_"+niveau,numquestfin);

			 if(nbQuestionRep>0){
			     double a = ((double)nbQuestionRep/(double)cptClick)*100;
			     reussite = (int)a;
			     mouchard.insertData("|reconnaissance|"+nomExercice+"_"+niveau,nomExercice,3,reussite,0);
			 }

			 fenetre.dispose();
		     }
		 }
	     }
				   );
	 
	 pane = new JPanel();
	 pane.setLayout(null);
	 fenetre.add(pane);
	
    }

	
       public void reprise(){
	   sortie.setBounds(new Rectangle(0,0,50, 20));
	   sortie.addActionListener(new ActionListener(){
		   public void actionPerformed(ActionEvent e){  
		       Object[] options = { "Quitter", "Annuler" };
		     int i= JOptionPane.showOptionDialog(fenetre, "Tu es sr de quitter, dans ce cas on enregistre ton travail", "Quitter?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);
		       
		       if (i == JOptionPane.YES_OPTION){ 
			   String numquestfin = ""+numero;
			   etudiant.modifieHistorique("|reconnaissance|"+nomExercice+"_"+niveau,numquestfin);
			 
			   if(nbQuestionRep>0){
			       double a = ((double)nbQuestionRep/(double)cptClick)*100;
			       reussite = (int)a;
			       mouchard.insertData("|reconnaissance|"+nomExercice+"_"+niveau,nomExercice,3,reussite,0);
			   }

			   fenetre.dispose();
		       }
		   }
	       }
				    );


	   String rep = etudiant.litHistorique("|reconnaissance|"+nomExercice+"_"+niveau,"");
	 
	   
	   if((rep.equals(""))||(rep.equals("0"))){
	       inter(0);
	   }
	   else{
	       int numquestion = (new Integer(rep)).intValue();
	       if(numquestion==nbQuestion){
		   Object[] options = { "Oui", "Non" };
		   int n= JOptionPane.showOptionDialog(fenetre, "Tu as dj fait cet exercice et tu l'as fini, veux tu le refaire?", "Reprise?",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);
		  
		   if (n == JOptionPane.YES_OPTION){ 
		       inter(0);
		   }
		   else{
		       fenetre.dispose();	   
		   }
	       }
	       else{ 
		   Object[] options = { "Reprendre", "Recommencer au dbut" };
		   int n1 = JOptionPane.showOptionDialog(fenetre, "Tu as dj commenc cet exercice, veux tu le continuer ou bien le refaire au dbut?", "Reprise de l'exercice",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE,null, options, options[0]);

		   if (n1 == JOptionPane.YES_OPTION){ 
		       System.out.println("reprise a "+rep);
		       inter(numquestion);
		   }   
		   else{
		       inter(0);
		   }
	       }
	   }
       }
        public void smile(){
	 if(nbClick<=nbClickAvant){
	     labelSmile.setIcon(iconSmile);
	 }
	 else{
	     labelSmile.setIcon(iconNotSmile);
	 }
     }

     public void inter(int num){
	 numero=num;
	 bouton.removeActionListener(e);
	 pane.removeAll();
	 labelReponse.setText("");
	 pane.add(sortie,null);
	 labelSmile = new JLabel(iconSmile);
	 labelSmile.setBounds(new Rectangle(868,0,115,100));
	 pane.add(labelSmile,null);
	 System.out.println("numero"+numero);
	 exo1 = (StructExoReconnaissance1)tabQuestion.get(numero);
	 icon = new ImageIcon(exo1.getUrlImage());
	 image = new JLabel(icon);

	 String[][] data = new String[exo1.getDonnees_propositions().size()][1];
	 String[] nomColonne = new String[1];
	 nomColonne[0]="Les propositions";
	

	 //la consigne
	 pane.add(enonce,null);
	 enonce.setBackground(new Color (97, 149, 207));
  	 enonce.setFont(new java.awt.Font("Arial", 1, 35));
  	 enonce.setForeground(new Color (209, 224, 104));
  	 enonce.setText(exo1.getConsigne());
  	 enonce.setBounds(new Rectangle(60, 10, 1000, 50));
	 
	
	  //Les propositions
	 int k=0;
	 for (Iterator i = exo1.getDonnees_propositions().iterator(); i.hasNext(); ){
	     String prop=(i.next()).toString();
	     data[k][0]=prop;
	     k++;
	 } 
	 tablePropositions = new JTable(data, nomColonne);
	 tablePropositions.setBackground(new Color(249, 157, 28));
	 tablePropositions.setFont(new java.awt.Font("Arial", 1, 60));
	 tablePropositions.setForeground(new Color(0, 120, 73));
	 tablePropositions.setBounds(new Rectangle (600, 125, 350, 400));
	 tablePropositions.setRowHeight(70);
	 JScrollPane scroll =  new JScrollPane(tablePropositions);
	 scroll.setBounds(new Rectangle (600, 125, 350, 400));
	 //pane.add(scroll,null);

	 pane.add(bouton, null);
	 pane.add(image, null);
	 pane.add(labelReponse,null);
  
	 bouton.setBounds(new Rectangle(700, 560, 90, 70));
	 bouton.setFont(new java.awt.Font("Arial", 1, 35));
  	 image.setBounds(new Rectangle(100, 200, 400, 300));
	 image.setBackground(Color.orange);
	 labelReponse.setBounds(new Rectangle (75, 550, 450, 70));
	 labelReponse.setFont(new java.awt.Font("Arial", 1, 60));
	 labelReponse.setBackground(new Color(249, 157, 28));
	 labelReponse.setForeground(new Color(0, 120, 73));
	 pane.setBackground(new Color (211, 32, 47));

	 //le listener du bouton
	 e = new ActionListener(){
		 public void actionPerformed(ActionEvent e){
		     cptClick++;
		     if(!(labelReponse.getText().equals(exo1.getReponse()))){
			 JOptionPane.showMessageDialog(fenetre,"Regardes bien, ce n'est pas le bon choix!","Erreur",JOptionPane.INFORMATION_MESSAGE,iconNotSmile);
			 nbClick++;
			 smile();
			 
		     }
		     else{	
			 if(nbClick==0){
			     JOptionPane.showMessageDialog(fenetre,"Bravo, et du premier coup!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
			 }
			 else{
			     JOptionPane.showMessageDialog(fenetre,"Bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
			 }
			 nbClickAvant=nbClick;
			 if(nbClick!=0){
			     nbClickTotal+=nbClick;
			 }
			 nbClick=0;
			 
			 numero+=1;
			 if(numero==nbQuestion){
			     if(nbClickTotal==0){
				 JOptionPane.showMessageDialog(fenetre, "Tu as russsi l'exercice sans faire aucune faute, bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
			     }
				  else{
				      JOptionPane.showMessageDialog(fenetre, "Tu as russsi l'exercice, bravo!","Bravo",JOptionPane.INFORMATION_MESSAGE,iconSmile);
				  }	
			     etudiant.modifieHistorique("|reconnaissance|"+nomExercice+"_"+niveau,""+nbQuestion);
			 
			     double a = ((double)(nbQuestionRep+1)/(double)cptClick)*100;
			     reussite = (int)a;
			     mouchard.insertData("|reconnaissance|"+nomExercice+"_"+niveau,nomExercice,3,reussite,1);
			     fenetre.dispose();
			 }
			 else{
			     inter(numero);
			     nbQuestionRep++;
			 }
		     }
		 }
	     };
	 bouton.addActionListener(e);		
	 pane.repaint();   
	 fenetre.show();
     }
   
     
     public static void main(String[] arguments) {
	 ExoReconnaissance3 exo = new ExoReconnaissance3("les saisons.txt", new Espion("charles foulon"),new Eleve("test"));
	 exo.reader();
	 exo.reprise();
	 //exo.inter(0);
    }
     
 
 }
